const Compiler = require('./compiler')
const Lexer = require('./lexer')
const Parser = require('./parser')

module.exports = function oslo(source, context) {
  const lexer = new Lexer()
  const tokens = lexer.scan(source)

  const parser = new Parser(tokens)
  const tree = parser.parse()

  const compiler = new Compiler()
  const result = compiler.compile(tree)

  return result
}
